diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/user.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/user.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/user.php	2013-07-16 23:46:09.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/user.php	2013-10-06 06:29:11.000000000 -0500
***************
*** 73,78 ****
--- 73,81 ----
  	if ( is_a($user, 'WP_User') ) { return $user; }
  
  	if ( empty($username) || empty($password) ) {
+ 		if ( is_wp_error( $user ) )
+ 			return $user;
+ 
  		$error = new WP_Error();
  
  		if ( empty($username) )
***************
*** 89,107 ****
  	if ( !$user )
  		return new WP_Error( 'invalid_username', sprintf( __( '<strong>ERROR</strong>: Invalid username. <a href="%s" title="Password Lost and Found">Lost your password</a>?' ), wp_lostpassword_url() ) );
  
- 	if ( is_multisite() ) {
- 		// Is user marked as spam?
- 		if ( 1 == $user->spam )
- 			return new WP_Error( 'spammer_account', __( '<strong>ERROR</strong>: Your account has been marked as a spammer.' ) );
- 
- 		// Is a user's blog marked as spam?
- 		if ( !is_super_admin( $user->ID ) && isset( $user->primary_blog ) ) {
- 			$details = get_blog_details( $user->primary_blog );
- 			if ( is_object( $details ) && $details->spam == 1 )
- 				return new WP_Error( 'blog_suspended', __( 'Site Suspended.' ) );
- 		}
- 	}
- 
  	$user = apply_filters('wp_authenticate_user', $user, $password);
  	if ( is_wp_error($user) )
  		return $user;
--- 92,97 ----
***************
*** 141,146 ****
--- 131,152 ----
  }
  
  /**
+  * For multisite blogs, check if the authenticated user has been marked as a
+  * spammer, or if the user's primary blog has been marked as spam.
+  *
+  * @since 3.7.0
+  */
+ function wp_authenticate_spam_check( $user ) {
+ 	if ( $user && is_a( $user, 'WP_User' ) && is_multisite() ) {
+ 		$spammed = apply_filters( 'check_is_user_spammed', is_user_spammy(), $user );
+ 
+ 		if ( $spammed )
+ 			return new WP_Error( 'spammer_account', __( '<strong>ERROR</strong>: Your account has been marked as a spammer.' ) );
+ 	}
+ 	return $user;
+ }
+ 
+ /**
   * Number of posts user has written.
   *
   * @since 3.0.0
***************
*** 242,249 ****
  	if ( ! $user = get_userdata( $user ) )
  		return false;
  
! 	if ( $user->has_prop( $wpdb->prefix . $option ) ) // Blog specific
! 		$result = $user->get( $wpdb->prefix . $option );
  	elseif ( $user->has_prop( $option ) ) // User specific and cross-blog
  		$result = $user->get( $option );
  	else
--- 248,256 ----
  	if ( ! $user = get_userdata( $user ) )
  		return false;
  
! 	$prefix = $wpdb->get_blog_prefix();
! 	if ( $user->has_prop( $prefix . $option ) ) // Blog specific
! 		$result = $user->get( $prefix . $option );
  	elseif ( $user->has_prop( $option ) ) // User specific and cross-blog
  		$result = $user->get( $option );
  	else
***************
*** 274,280 ****
  	global $wpdb;
  
  	if ( !$global )
! 		$option_name = $wpdb->prefix . $option_name;
  
  	return update_user_meta( $user_id, $option_name, $newvalue );
  }
--- 281,287 ----
  	global $wpdb;
  
  	if ( !$global )
! 		$option_name = $wpdb->get_blog_prefix() . $option_name;
  
  	return update_user_meta( $user_id, $option_name, $newvalue );
  }
***************
*** 298,304 ****
  	global $wpdb;
  
  	if ( !$global )
! 		$option_name = $wpdb->prefix . $option_name;
  	return delete_user_meta( $user_id, $option_name );
  }
  
--- 305,311 ----
  	global $wpdb;
  
  	if ( !$global )
! 		$option_name = $wpdb->get_blog_prefix() . $option_name;
  	return delete_user_meta( $user_id, $option_name );
  }
  
***************
*** 403,439 ****
  			$this->query_fields = "$wpdb->users.ID";
  		}
  
! 		if ( $qv['count_total'] )
  			$this->query_fields = 'SQL_CALC_FOUND_ROWS ' . $this->query_fields;
  
  		$this->query_from = "FROM $wpdb->users";
  		$this->query_where = "WHERE 1=1";
  
  		// sorting
! 		if ( in_array( $qv['orderby'], array('nicename', 'email', 'url', 'registered') ) ) {
! 			$orderby = 'user_' . $qv['orderby'];
! 		} elseif ( in_array( $qv['orderby'], array('user_nicename', 'user_email', 'user_url', 'user_registered') ) ) {
! 			$orderby = $qv['orderby'];
! 		} elseif ( 'name' == $qv['orderby'] || 'display_name' == $qv['orderby'] ) {
! 			$orderby = 'display_name';
! 		} elseif ( 'post_count' == $qv['orderby'] ) {
! 			// todo: avoid the JOIN
! 			$where = get_posts_by_author_sql('post');
! 			$this->query_from .= " LEFT OUTER JOIN (
! 				SELECT post_author, COUNT(*) as post_count
! 				FROM $wpdb->posts
! 				$where
! 				GROUP BY post_author
! 			) p ON ({$wpdb->users}.ID = p.post_author)
! 			";
! 			$orderby = 'post_count';
! 		} elseif ( 'ID' == $qv['orderby'] || 'id' == $qv['orderby'] ) {
! 			$orderby = 'ID';
! 		} else {
! 			$orderby = 'user_login';
  		}
  
! 		$qv['order'] = strtoupper( $qv['order'] );
  		if ( 'ASC' == $qv['order'] )
  			$order = 'ASC';
  		else
--- 410,453 ----
  			$this->query_fields = "$wpdb->users.ID";
  		}
  
! 		if ( isset( $qv['count_total'] ) && $qv['count_total'] )
  			$this->query_fields = 'SQL_CALC_FOUND_ROWS ' . $this->query_fields;
  
  		$this->query_from = "FROM $wpdb->users";
  		$this->query_where = "WHERE 1=1";
  
  		// sorting
! 		if ( isset( $qv['orderby'] ) ) {
! 			if ( in_array( $qv['orderby'], array('nicename', 'email', 'url', 'registered') ) ) {
! 				$orderby = 'user_' . $qv['orderby'];
! 			} elseif ( in_array( $qv['orderby'], array('user_nicename', 'user_email', 'user_url', 'user_registered') ) ) {
! 				$orderby = $qv['orderby'];
! 			} elseif ( 'name' == $qv['orderby'] || 'display_name' == $qv['orderby'] ) {
! 				$orderby = 'display_name';
! 			} elseif ( 'post_count' == $qv['orderby'] ) {
! 				// todo: avoid the JOIN
! 				$where = get_posts_by_author_sql('post');
! 				$this->query_from .= " LEFT OUTER JOIN (
! 					SELECT post_author, COUNT(*) as post_count
! 					FROM $wpdb->posts
! 					$where
! 					GROUP BY post_author
! 				) p ON ({$wpdb->users}.ID = p.post_author)
! 				";
! 				$orderby = 'post_count';
! 			} elseif ( 'ID' == $qv['orderby'] || 'id' == $qv['orderby'] ) {
! 				$orderby = 'ID';
! 			} elseif ( 'meta_value' == $qv['orderby'] ) {
! 				$orderby = "$wpdb->usermeta.meta_value";
! 			} else {
! 				$orderby = 'user_login';
! 			}
  		}
  
! 		if ( empty( $orderby ) )
! 			$orderby = 'user_login';
! 
! 		$qv['order'] = isset( $qv['order'] ) ? strtoupper( $qv['order'] ) : '';
  		if ( 'ASC' == $qv['order'] )
  			$order = 'ASC';
  		else
***************
*** 441,454 ****
  		$this->query_orderby = "ORDER BY $orderby $order";
  
  		// limit
! 		if ( $qv['number'] ) {
  			if ( $qv['offset'] )
  				$this->query_limit = $wpdb->prepare("LIMIT %d, %d", $qv['offset'], $qv['number']);
  			else
  				$this->query_limit = $wpdb->prepare("LIMIT %d", $qv['number']);
  		}
  
! 		$search = trim( $qv['search'] );
  		if ( $search ) {
  			$leading_wild = ( ltrim($search, '*') != $search );
  			$trailing_wild = ( rtrim($search, '*') != $search );
--- 455,471 ----
  		$this->query_orderby = "ORDER BY $orderby $order";
  
  		// limit
! 		if ( isset( $qv['number'] ) && $qv['number'] ) {
  			if ( $qv['offset'] )
  				$this->query_limit = $wpdb->prepare("LIMIT %d, %d", $qv['offset'], $qv['number']);
  			else
  				$this->query_limit = $wpdb->prepare("LIMIT %d", $qv['number']);
  		}
  
! 		$search = '';
! 		if ( isset( $qv['search'] ) )
! 			$search = trim( $qv['search'] );
! 
  		if ( $search ) {
  			$leading_wild = ( ltrim($search, '*') != $search );
  			$trailing_wild = ( rtrim($search, '*') != $search );
***************
*** 482,497 ****
  			$this->query_where .= $this->get_search_sql( $search, $search_columns, $wild );
  		}
  
! 		$blog_id = absint( $qv['blog_id'] );
  
! 		if ( 'authors' == $qv['who'] && $blog_id ) {
  			$qv['meta_key'] = $wpdb->get_blog_prefix( $blog_id ) . 'user_level';
  			$qv['meta_value'] = 0;
  			$qv['meta_compare'] = '!=';
  			$qv['blog_id'] = $blog_id = 0; // Prevent extra meta query
  		}
  
! 		$role = trim( $qv['role'] );
  
  		if ( $blog_id && ( $role || is_multisite() ) ) {
  			$cap_meta_query = array();
--- 499,518 ----
  			$this->query_where .= $this->get_search_sql( $search, $search_columns, $wild );
  		}
  
! 		$blog_id = 0;
! 		if ( isset( $qv['blog_id'] ) )
! 			$blog_id = absint( $qv['blog_id'] );
  
! 		if ( isset( $qv['who'] ) && 'authors' == $qv['who'] && $blog_id ) {
  			$qv['meta_key'] = $wpdb->get_blog_prefix( $blog_id ) . 'user_level';
  			$qv['meta_value'] = 0;
  			$qv['meta_compare'] = '!=';
  			$qv['blog_id'] = $blog_id = 0; // Prevent extra meta query
  		}
  
! 		$role = '';
! 		if ( isset( $qv['role'] ) )
! 			$role = trim( $qv['role'] );
  
  		if ( $blog_id && ( $role || is_multisite() ) ) {
  			$cap_meta_query = array();
***************
*** 517,526 ****
  				$this->query_fields = 'DISTINCT ' . $this->query_fields;
  		}
  
! 		if ( !empty( $qv['include'] ) ) {
  			$ids = implode( ',', wp_parse_id_list( $qv['include'] ) );
  			$this->query_where .= " AND $wpdb->users.ID IN ($ids)";
! 		} elseif ( !empty($qv['exclude']) ) {
  			$ids = implode( ',', wp_parse_id_list( $qv['exclude'] ) );
  			$this->query_where .= " AND $wpdb->users.ID NOT IN ($ids)";
  		}
--- 538,547 ----
  				$this->query_fields = 'DISTINCT ' . $this->query_fields;
  		}
  
! 		if ( ! empty( $qv['include'] ) ) {
  			$ids = implode( ',', wp_parse_id_list( $qv['include'] ) );
  			$this->query_where .= " AND $wpdb->users.ID IN ($ids)";
! 		} elseif ( ! empty( $qv['exclude'] ) ) {
  			$ids = implode( ',', wp_parse_id_list( $qv['exclude'] ) );
  			$this->query_where .= " AND $wpdb->users.ID NOT IN ($ids)";
  		}
***************
*** 545,551 ****
  			$this->results = $wpdb->get_col("SELECT $this->query_fields $this->query_from $this->query_where $this->query_orderby $this->query_limit");
  		}
  
! 		if ( $qv['count_total'] )
  			$this->total_users = $wpdb->get_var( apply_filters( 'found_users_query', 'SELECT FOUND_ROWS()' ) );
  
  		if ( !$this->results )
--- 566,572 ----
  			$this->results = $wpdb->get_col("SELECT $this->query_fields $this->query_from $this->query_where $this->query_orderby $this->query_limit");
  		}
  
! 		if ( isset( $qv['count_total'] ) && $qv['count_total'] )
  			$this->total_users = $wpdb->get_var( apply_filters( 'found_users_query', 'SELECT FOUND_ROWS()' ) );
  
  		if ( !$this->results )
***************
*** 1519,1546 ****
   */
  function _get_additional_user_keys( $user ) {
  	$keys = array( 'first_name', 'last_name', 'nickname', 'description', 'rich_editing', 'comment_shortcuts', 'admin_color', 'use_ssl', 'show_admin_bar_front' );
! 	return array_merge( $keys, array_keys( _wp_get_user_contactmethods( $user ) ) );
  }
  
  /**
!  * Set up the contact methods.
   *
   * Default contact methods were removed in 3.6. A filter dictates contact methods.
   *
!  * @since 2.9.0
!  * @access private
   *
!  * @param object $user User data object (optional).
!  * @return array $user_contactmethods Array of contact methods and their labels.
   */
! function _wp_get_user_contactmethods( $user = null ) {
! 	$user_contactmethods = array();
  	if ( get_site_option( 'initial_db_version' ) < 23588 ) {
! 		$user_contactmethods = array(
  			'aim'    => __( 'AIM' ),
  			'yim'    => __( 'Yahoo IM' ),
  			'jabber' => __( 'Jabber / Google Talk' )
  		);
  	}
! 	return apply_filters( 'user_contactmethods', $user_contactmethods, $user );
  }
--- 1540,1711 ----
   */
  function _get_additional_user_keys( $user ) {
  	$keys = array( 'first_name', 'last_name', 'nickname', 'description', 'rich_editing', 'comment_shortcuts', 'admin_color', 'use_ssl', 'show_admin_bar_front' );
! 	return array_merge( $keys, array_keys( wp_get_user_contact_methods( $user ) ) );
  }
  
  /**
!  * Set up the user contact methods.
   *
   * Default contact methods were removed in 3.6. A filter dictates contact methods.
   *
!  * @since 3.7.0
   *
!  * @param WP_User $user Optional. WP_User object.
!  * @return array Array of contact methods and their labels.
   */
! function wp_get_user_contact_methods( $user = null ) {
! 	$methods = array();
  	if ( get_site_option( 'initial_db_version' ) < 23588 ) {
! 		$methods = array(
  			'aim'    => __( 'AIM' ),
  			'yim'    => __( 'Yahoo IM' ),
  			'jabber' => __( 'Jabber / Google Talk' )
  		);
  	}
! 
! 	/**
! 	 * Filter the user contact methods.
! 	 *
! 	 * @since 2.9.0
! 	 *
! 	 * @param array   $methods Array of contact methods and their labels.
!  	 * @param WP_User $user    Optional. WP_User object.
! 	 */
! 	return apply_filters( 'user_contactmethods', $methods, $user );
! }
! 
! /**
!  * The old private function for setting up user contact methods.
!  *
!  * @since 2.9.0
!  * @access private
!  */
! function _wp_get_user_contactmethods( $user = null ) {
! 	return wp_get_user_contact_methods( $user );
! }
! 
! /**
!  * Retrieves a user row based on password reset key and login
!  *
!  * A key is considered 'expired' if it exactly matches the value of the
!  * user_activation_key field, rather than being matched after going through the
!  * hashing process. This field is now hashed; old values are no longer accepted
!  * but have a different WP_Error code so good user feedback can be provided.
!  *
!  * @uses $wpdb WordPress Database object
!  *
!  * @param string $key       Hash to validate sending user's password.
!  * @param string $login     The user login.
!  * @return WP_User|WP_Error WP_User object on success, WP_Error object for invalid or expired keys.
!  */
! function check_password_reset_key($key, $login) {
! 	global $wpdb, $wp_hasher;
! 
! 	$key = preg_replace('/[^a-z0-9]/i', '', $key);
! 
! 	if ( empty( $key ) || !is_string( $key ) )
! 		return new WP_Error('invalid_key', __('Invalid key'));
! 
! 	if ( empty($login) || !is_string($login) )
! 		return new WP_Error('invalid_key', __('Invalid key'));
! 
! 	$row = $wpdb->get_row( $wpdb->prepare( "SELECT ID, user_activation_key FROM $wpdb->users WHERE user_login = %s", $login ) );
! 	if ( ! $row )
! 		return new WP_Error('invalid_key', __('Invalid key'));
! 
! 	if ( empty( $wp_hasher ) ) {
! 		require_once ABSPATH . 'wp-includes/class-phpass.php';
! 		$wp_hasher = new PasswordHash( 8, true );
! 	}
! 
! 	if ( $wp_hasher->CheckPassword( $key, $row->user_activation_key ) )
! 		return get_userdata( $row->ID );
! 
! 	if ( $key === $row->user_activation_key ) {
! 		$return = new WP_Error( 'expired_key', __( 'Invalid key' ) );
! 		$user_id = $row->ID;
! 
! 		/**
! 		 * Filter the return value of check_password_reset_key() when an
! 		 * old-style key is used (plain-text key was stored in the database).
! 		 *
! 		 * @since 3.7.0
! 		 *
! 		 * @param WP_Error $return  A WP_Error object denoting an expired key.
! 		 *                          Return a WP_User object to validate the key.
! 		 * @param int      $user_id The matched user ID.
! 		 */
! 		return apply_filters( 'password_reset_key_expired', $return, $user_id );
! 	}
! 
! 	return new WP_Error( 'invalid_key', __( 'Invalid key' ) );
! }
! 
! /**
!  * Handles resetting the user's password.
!  *
!  * @param object $user The user
!  * @param string $new_pass New password for the user in plaintext
!  */
! function reset_password( $user, $new_pass ) {
! 	do_action( 'password_reset', $user, $new_pass );
! 
! 	wp_set_password( $new_pass, $user->ID );
! 	update_user_option( $user->ID, 'default_password_nag', false, true );
! 
! 	wp_password_change_notification( $user );
! }
! 
! /**
!  * Handles registering a new user.
!  *
!  * @param string $user_login User's username for logging in
!  * @param string $user_email User's email address to send password and add
!  * @return int|WP_Error Either user's ID or error on failure.
!  */
! function register_new_user( $user_login, $user_email ) {
! 	$errors = new WP_Error();
! 
! 	$sanitized_user_login = sanitize_user( $user_login );
! 	$user_email = apply_filters( 'user_registration_email', $user_email );
! 
! 	// Check the username
! 	if ( $sanitized_user_login == '' ) {
! 		$errors->add( 'empty_username', __( '<strong>ERROR</strong>: Please enter a username.' ) );
! 	} elseif ( ! validate_username( $user_login ) ) {
! 		$errors->add( 'invalid_username', __( '<strong>ERROR</strong>: This username is invalid because it uses illegal characters. Please enter a valid username.' ) );
! 		$sanitized_user_login = '';
! 	} elseif ( username_exists( $sanitized_user_login ) ) {
! 		$errors->add( 'username_exists', __( '<strong>ERROR</strong>: This username is already registered. Please choose another one.' ) );
! 	}
! 
! 	// Check the e-mail address
! 	if ( $user_email == '' ) {
! 		$errors->add( 'empty_email', __( '<strong>ERROR</strong>: Please type your e-mail address.' ) );
! 	} elseif ( ! is_email( $user_email ) ) {
! 		$errors->add( 'invalid_email', __( '<strong>ERROR</strong>: The email address isn&#8217;t correct.' ) );
! 		$user_email = '';
! 	} elseif ( email_exists( $user_email ) ) {
! 		$errors->add( 'email_exists', __( '<strong>ERROR</strong>: This email is already registered, please choose another one.' ) );
! 	}
! 
! 	do_action( 'register_post', $sanitized_user_login, $user_email, $errors );
! 
! 	$errors = apply_filters( 'registration_errors', $errors, $sanitized_user_login, $user_email );
! 
! 	if ( $errors->get_error_code() )
! 		return $errors;
! 
! 	$user_pass = wp_generate_password( 12, false );
! 	$user_id = wp_create_user( $sanitized_user_login, $user_pass, $user_email );
! 	if ( ! $user_id || is_wp_error( $user_id ) ) {
! 		$errors->add( 'registerfail', sprintf( __( '<strong>ERROR</strong>: Couldn&#8217;t register you&hellip; please contact the <a href="mailto:%s">webmaster</a> !' ), get_option( 'admin_email' ) ) );
! 		return $errors;
! 	}
! 
! 	update_user_option( $user_id, 'default_password_nag', true, true ); //Set up the Password change nag.
! 
! 	wp_new_user_notification( $user_id, $user_pass );
! 
! 	return $user_id;
  }
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/vars.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/vars.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/vars.php	2013-07-08 15:27:06.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/vars.php	2013-10-23 09:40:10.000000000 -0500
***************
*** 52,58 ****
  		$is_lynx = true;
  	} elseif ( stripos($_SERVER['HTTP_USER_AGENT'], 'chrome') !== false ) {
  		if ( stripos( $_SERVER['HTTP_USER_AGENT'], 'chromeframe' ) !== false ) {
! 			if ( $is_chrome = apply_filters( 'use_google_chrome_frame', is_admin() ) )
  				header( 'X-UA-Compatible: chrome=1' );
  			$is_winIE = ! $is_chrome;
  		} else {
--- 52,66 ----
  		$is_lynx = true;
  	} elseif ( stripos($_SERVER['HTTP_USER_AGENT'], 'chrome') !== false ) {
  		if ( stripos( $_SERVER['HTTP_USER_AGENT'], 'chromeframe' ) !== false ) {
! 			$is_admin = is_admin();
! 			/**
! 			 * Filter whether Google Chrome Frame should be used, if available.
! 			 *
! 			 * @since 3.2.0
! 			 *
! 			 * @param bool $is_admin Whether to use the Google Chrome Frame. Default is the value of is_admin().
! 			 */
! 			if ( $is_chrome = apply_filters( 'use_google_chrome_frame', $is_admin ) )
  				header( 'X-UA-Compatible: chrome=1' );
  			$is_winIE = ! $is_chrome;
  		} else {
***************
*** 60,71 ****
  		}
  	} elseif ( stripos($_SERVER['HTTP_USER_AGENT'], 'safari') !== false ) {
  		$is_safari = true;
! 	} elseif ( strpos($_SERVER['HTTP_USER_AGENT'], 'Gecko') !== false ) {
! 		$is_gecko = true;
! 	} elseif ( strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false && strpos($_SERVER['HTTP_USER_AGENT'], 'Win') !== false ) {
  		$is_winIE = true;
  	} elseif ( strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false && strpos($_SERVER['HTTP_USER_AGENT'], 'Mac') !== false ) {
  		$is_macIE = true;
  	} elseif ( strpos($_SERVER['HTTP_USER_AGENT'], 'Opera') !== false ) {
  		$is_opera = true;
  	} elseif ( strpos($_SERVER['HTTP_USER_AGENT'], 'Nav') !== false && strpos($_SERVER['HTTP_USER_AGENT'], 'Mozilla/4.') !== false ) {
--- 68,79 ----
  		}
  	} elseif ( stripos($_SERVER['HTTP_USER_AGENT'], 'safari') !== false ) {
  		$is_safari = true;
! 	} elseif ( ( strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false || strpos($_SERVER['HTTP_USER_AGENT'], 'Trident') !== false ) && strpos($_SERVER['HTTP_USER_AGENT'], 'Win') !== false ) {
  		$is_winIE = true;
  	} elseif ( strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false && strpos($_SERVER['HTTP_USER_AGENT'], 'Mac') !== false ) {
  		$is_macIE = true;
+ 	} elseif ( strpos($_SERVER['HTTP_USER_AGENT'], 'Gecko') !== false ) {
+ 		$is_gecko = true;
  	} elseif ( strpos($_SERVER['HTTP_USER_AGENT'], 'Opera') !== false ) {
  		$is_opera = true;
  	} elseif ( strpos($_SERVER['HTTP_USER_AGENT'], 'Nav') !== false && strpos($_SERVER['HTTP_USER_AGENT'], 'Mozilla/4.') !== false ) {
***************
*** 87,92 ****
--- 95,106 ----
  $is_apache = (strpos($_SERVER['SERVER_SOFTWARE'], 'Apache') !== false || strpos($_SERVER['SERVER_SOFTWARE'], 'LiteSpeed') !== false);
  
  /**
+  * Whether the server software is Nginx or something else
+  * @global bool $is_nginx
+  */
+ $is_nginx = (strpos($_SERVER['SERVER_SOFTWARE'], 'nginx') !== false);
+ 
+ /**
   * Whether the server software is IIS or something else
   * @global bool $is_IIS
   */
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/version.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/version.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/version.php	2013-09-11 14:13:02.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/version.php	2013-10-24 14:36:09.000000000 -0500
***************
*** 4,24 ****
   *
   * @global string $wp_version
   */
! $wp_version = '3.6.1';
  
  /**
   * Holds the WordPress DB revision, increments when changes are made to the WordPress DB schema.
   *
   * @global int $wp_db_version
   */
! $wp_db_version = 24448;
  
  /**
   * Holds the TinyMCE version
   *
   * @global string $tinymce_version
   */
! $tinymce_version = '358-25336';
  
  /**
   * Holds the required PHP version
--- 4,24 ----
   *
   * @global string $wp_version
   */
! $wp_version = '3.7';
  
  /**
   * Holds the WordPress DB revision, increments when changes are made to the WordPress DB schema.
   *
   * @global int $wp_db_version
   */
! $wp_db_version = 25824;
  
  /**
   * Holds the TinyMCE version
   *
   * @global string $tinymce_version
   */
! $tinymce_version = '359-20131018';
  
  /**
   * Holds the required PHP version
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/widgets.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/widgets.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/widgets.php	2013-05-19 07:32:20.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/widgets.php	2013-10-22 18:58:10.000000000 -0500
***************
*** 833,852 ****
  /**
   * Display dynamic sidebar.
   *
!  * By default it displays the default sidebar or 'sidebar-1'. The 'sidebar-1' is
!  * not named by the theme, the actual name is '1', but 'sidebar-' is added to
!  * the registered sidebars for the name. If you named your sidebar 'after-post',
!  * then the parameter $index will still be 'after-post', but the lookup will be
!  * for 'sidebar-after-post'.
!  *
!  * It is confusing for the $index parameter, but just know that it should just
!  * work. When you register the sidebar in the theme, you will use the same name
!  * for this function or "Pay no heed to the man behind the curtain." Just accept
!  * it as an oddity of WordPress sidebar register and display.
   *
   * @since 2.2.0
   *
!  * @param int|string $index Optional, default is 1. Name or ID of dynamic sidebar.
   * @return bool True, if widget sidebar was found and called. False if not found or not called.
   */
  function dynamic_sidebar($index = 1) {
--- 833,845 ----
  /**
   * Display dynamic sidebar.
   *
!  * By default this displays the default sidebar or 'sidebar-1'. If your theme specifies the 'id' or
!  * 'name' parameter for its registered sidebars you can pass an id or name as the $index parameter.
!  * Otherwise, you can pass in a numerical index to display the sidebar at that index.
   *
   * @since 2.2.0
   *
!  * @param int|string $index Optional, default is 1. Index, name or ID of dynamic sidebar.
   * @return bool True, if widget sidebar was found and called. False if not found or not called.
   */
  function dynamic_sidebar($index = 1) {
***************
*** 865,875 ****
  	}
  
  	$sidebars_widgets = wp_get_sidebars_widgets();
! 	if ( empty( $sidebars_widgets ) )
! 		return false;
! 
! 	if ( empty($wp_registered_sidebars[$index]) || !array_key_exists($index, $sidebars_widgets) || !is_array($sidebars_widgets[$index]) || empty($sidebars_widgets[$index]) )
  		return false;
  
  	$sidebar = $wp_registered_sidebars[$index];
  
--- 858,866 ----
  	}
  
  	$sidebars_widgets = wp_get_sidebars_widgets();
! 	if ( empty( $wp_registered_sidebars[ $index ] ) || empty( $sidebars_widgets[ $index ] ) || ! is_array( $sidebars_widgets[ $index ] ) ) {
  		return false;
+ 	}
  
  	$sidebar = $wp_registered_sidebars[$index];
  
***************
*** 984,993 ****
  function is_active_sidebar( $index ) {
  	$index = ( is_int($index) ) ? "sidebar-$index" : sanitize_title($index);
  	$sidebars_widgets = wp_get_sidebars_widgets();
! 	if ( !empty($sidebars_widgets[$index]) )
! 		return true;
! 
! 	return false;
  }
  
  /* Internal Functions */
--- 975,982 ----
  function is_active_sidebar( $index ) {
  	$index = ( is_int($index) ) ? "sidebar-$index" : sanitize_title($index);
  	$sidebars_widgets = wp_get_sidebars_widgets();
! 	$is_active_sidebar = ! empty( $sidebars_widgets[$index] );
! 	return $is_active_sidebar;
  }
  
  /* Internal Functions */
***************
*** 1008,1014 ****
  	if ( $deprecated !== true )
  		_deprecated_argument( __FUNCTION__, '2.8.1' );
  
! 	global $wp_registered_widgets, $_wp_sidebars_widgets, $sidebars_widgets;
  
  	// If loading from front page, consult $_wp_sidebars_widgets rather than options
  	// to see if wp_convert_widget_settings() has made manipulations in memory.
--- 997,1003 ----
  	if ( $deprecated !== true )
  		_deprecated_argument( __FUNCTION__, '2.8.1' );
  
! 	global $_wp_sidebars_widgets, $sidebars_widgets;
  
  	// If loading from front page, consult $_wp_sidebars_widgets rather than options
  	// to see if wp_convert_widget_settings() has made manipulations in memory.
***************
*** 1172,1178 ****
  
  // look for "lost" widgets, this has to run at least on each theme change
  function retrieve_widgets($theme_changed = false) {
! 	global $wp_registered_widget_updates, $wp_registered_sidebars, $sidebars_widgets, $wp_registered_widgets;
  
  	$registered_sidebar_keys = array_keys( $wp_registered_sidebars );
  	$orphaned = 0;
--- 1161,1167 ----
  
  // look for "lost" widgets, this has to run at least on each theme change
  function retrieve_widgets($theme_changed = false) {
! 	global $wp_registered_sidebars, $sidebars_widgets, $wp_registered_widgets;
  
  	$registered_sidebar_keys = array_keys( $wp_registered_sidebars );
  	$orphaned = 0;
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/wp-db.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/wp-db.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/wp-db.php	2013-07-29 13:15:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/wp-db.php	2013-09-06 12:07:09.000000000 -0500
***************
*** 1180,1187 ****
  	function query( $query ) {
  		if ( ! $this->ready )
  			return false;
! 
! 		// some queries are made before the plugins have been loaded, and thus cannot be filtered with this method
  		$query = apply_filters( 'query', $query );
  
  		$return_val = 0;
--- 1180,1193 ----
  	function query( $query ) {
  		if ( ! $this->ready )
  			return false;
! 		/**
! 		 * Filter the database query.
! 		 *
! 		 * Some queries are made before the plugins have been loaded, and thus cannot be filtered with this method.
! 		 *
! 		 * @since 2.1.0
! 		 * @param string $query Database query.
! 		 */
  		$query = apply_filters( 'query', $query );
  
  		$return_val = 0;
